#ifndef COMMUNICATIONTAB_H
#define COMMUNICATIONTAB_H

#include <QDialog>
#include <QtGui>

/*class QDialogButtonBox;*/
/*class QFileInfo;*/
/*class QTabWidget;*/

#include "motortab.h"

#define NUM_COMM_PARAMS 13
#define POS           0
#define SPEED         1
#define CURRENT       2 
#define REF           3
#define ERROR         4
#define ERROR_REF_FB  5
#define UFF           6
#define UDI           7
#define UFB           8
#define UPA           9
#define U             10
#define USAT          11
#define Y 	          12

const QString dataCommParamNames[NUM_COMM_PARAMS] = {"Position","Speed","Current", "Reference", "Error", "Error_ref_fb", "Control FeedForward", "Control Direct", "Control FeedBack", "Control Parallel", "Control", "ControlSat", "Output"};
const QString dataCommParamNamesSimple[NUM_COMM_PARAMS] = {"pos","vel","cur", "ref", "err", "err_ref_fb", "uFF", "uDI", "uFB", "uPA", "u", "uSat", "y"};


class CommunicationMotorTab : public QWidget
{
	Q_OBJECT

	public:
		CommunicationMotorTab(void);

		QSpinBox 				*Ttransmission;
		QDoubleSpinBox 	*TlimitTransmission;
		QCheckBox				*DataCommParam[NUM_COMM_PARAMS];
};

class CommunicationTab : public QWidget
{
	Q_OBJECT

	public:
		CommunicationTab(MotorTab *motor_tab);

		unsigned int 	getCommunicationTransmissionFreq 	( unsigned char u_motor );
		float 				getCommunicationTimeLimit 				( unsigned char u_motor );
		char* 				getCommunicationParamName 				( unsigned char u_param );
		unsigned char getNumParams 											( void );
		unsigned char getCommunicationParamValue 				( unsigned char u_motor , unsigned char u_param);

		void 					enableCommunication								( unsigned char u_motor );
		void 					disableCommunication								( unsigned char u_motor );
		void 					setCommunicationTransmissionFreq 	( unsigned char u_motor , unsigned int u_freq);
		void  				setCommunicationTimeLimit 				( unsigned char u_motor , float f_time_limit);
		void 					setCommunicationParamValue 				( unsigned char u_motor , unsigned char u_param, unsigned char u_value);

		CommunicationMotorTab  *communicationMotorTab[NUM_MOTORS];
};

#endif
