#include "camerawindow.h"
#include "ui_camerawindow.h"
#include <QDebug>
#include <QSettings>
#include <QComboBox>
#include <QLineEdit>
#include <QCloseEvent>

#include <fstream>
#include <string.h>
#include <iostream>

CameraWindow::CameraWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::CameraWindow)
{
	ui->setupUi(this);
  
	sCameraIP.clear();
	sCameraIP.append("http://138.100.21.254/asignaturas/seco/robolabo.jpg");
  /* Set Network Manager */
	m_netwManager = new QNetworkAccessManager(this);
	connect(m_netwManager, SIGNAL(finished(QNetworkReply*)), this, SLOT(slot_netwManagerFinished(QNetworkReply*)));

	/* Set timer */
	m_TCamera = new QTimer(this);
	connect(m_TCamera, SIGNAL(timeout()), this, SLOT(getImage()));
	//m_TCamera->start(100);
}

CameraWindow::~CameraWindow()
{
    delete ui;
}

void CameraWindow::getImage()
{
	//QUrl url("http://192.168.2.180:80/jpg/1/image.jpg");
	//QUrl url("http://138.100.21.254:3010/jpg/1/image.jpg");
	QUrl url(sCameraIP);
	//QByteArray tmp = sCameraIP.toLatin1();
	//const char *kk = tmp.data();
	//printf("CameraIP: %s\n", kk);
	
	//QByteArray tmp = sCameraIP.toLatin1();
	//const char *kk = tmp.data();
	//printf("ADDRESS: %s\n", kk);
	//QUrl url(ui->m_cbAddress->currentText());
	//if ( ! url.isValid()) {
	//qDebug() << "Invalid url" << url;
	//return;
	//}
	//qDebug() << "Starting to download" << url;
	QNetworkRequest request(url);
	/*
		 [HTTP_USER_AGENT] => Opera/9.80 (X11; Linux x86_64; U; lt) Presto/2.6.31 Version/10.70
		 [HTTP_HOST] => vvv.laisvas.lt [HTTP_ACCEPT] => text/html, application/xml;q=0.9, application/xhtml+xml, image/png, image/jpeg, image/gif, image/x-xbitmap, * / *;q=0.1
		 [HTTP_ACCEPT_LANGUAGE] => lt-LT,lt;q=0.9,en;q=0.8
		 [HTTP_ACCEPT_CHARSET] => iso-8859-1, utf-8, utf-16, *;q=0.1
		 [HTTP_ACCEPT_ENCODING] => deflate, gzip, x-gzip, identity, *;q=0
		 [HTTP_CACHE_CONTROL] => no-cache
		 [HTTP_CONNECTION] => Keep-Alive, TE
		 [HTTP_TE] => deflate, gzip, chunked, identity, trailers
	 */
	// imitate opera browser.
	//request.setRawHeader("User-Agent", "Opera/9.80 (X11; Linux x86_64; U; en) Presto/2.6.31 Version/10.70");
	//request.setRawHeader("Accept", "text/html, application/xml;q=0.9, application/xhtml+xml, image/png, image/jpeg, image/gif, image/x-xbitmap, */*;q=0.1");
	//request.setRawHeader("Accept-Language", "lt-LT,lt;q=0.9,en;q=0.8");
	//request.setRawHeader("Accept-Charset", "iso-8859-1, utf-8, utf-16, *;q=0.1");
	//request.setRawHeader("Accept-Encoding","deflate, gzip, x-gzip, identity, *;q=0");
	request.setRawHeader("Authorization", "Basic " + QByteArray(QString("%1:%2").arg("root").arg("seco").toAscii()).toBase64()); 

	m_netwManager->get(request);
}

void CameraWindow::slot_netwManagerFinished(QNetworkReply *reply)
{
    if (reply->error() != QNetworkReply::NoError) {
			//qDebug() << "Error in" << reply->url() << ":" << reply->errorString();
        reply->deleteLater();
        return;
    }
    QVariant redir = reply->attribute(QNetworkRequest::RedirectionTargetAttribute);
    if (redir.isValid()) {
        QUrl url = redir.toUrl();
				//qDebug() << "must go to:" << url;
        if (url.isRelative()) {
					//qDebug() << "Is relative setting scheme and host";
            url.setScheme(reply->url().scheme());
            url.setEncodedHost(reply->url().encodedHost());
        }
        QNetworkRequest req(url);
        m_netwManager->get(req);
        reply->deleteLater();
        return;
    }
		//qDebug() << "ContentType:" << reply->header(QNetworkRequest::ContentTypeHeader).toString();

    QByteArray jpegData = reply->readAll();
		
		//QImage logo("aguti.jpg");
    QPixmap pixmap;
		pixmap.loadFromData(jpegData);
		//pixmap.fromImage(logo);
		ui->m_lblImage->setPixmap(pixmap);
		//ui->statusBar->showMessage(QString("%1").arg(reply->url().toString()));
    reply->deleteLater();
}

void CameraWindow::cameraStart ( QString s_camera_ip, unsigned int un_camera_port)
{
	/* Clear data on sCameraIP */
	sCameraIP.clear();
	/* Transform string to QString */
	sCameraIP.append("http://");
	sCameraIP.append(s_camera_ip);
	sCameraIP.append(":");
	sCameraIP.append(QString("%1").arg(un_camera_port));
	sCameraIP.append("/jpg/1/image.jpg");
	/* Start timer */
	m_TCamera->start(40);

	
	/* DEBUG */
	//QByteArray tmp = sCameraIP.toLatin1();
	//const char *kk = tmp.data();
	//printf("CameraIP: %s - PORT: %d\n", kk, un_camera_port);
	/* DEBUG */

}

void CameraWindow::cameraStop ( void )
{
	/* Clear data on sCameraIP */
	sCameraIP.clear();
	sCameraIP.append("http://138.100.21.254/asignaturas/seco/robolabo.jpg");
	m_TCamera->stop();
}
