#include "networktab.h"

/****************************************
 * **************************************/
NetworkTab::NetworkTab() 
{

	/* Auth */
	QGroupBox *authGroupBox = new QGroupBox(tr("Authentification"));
	QFormLayout *authLayout = new QFormLayout;
	
	userValue 	= new QLineEdit("");
	userValue->setFixedWidth(150);
	passValue 	= new QLineEdit("");
	passValue->setFixedWidth(150);
	authButton 	= new QPushButton(tr("Validate"));
	authButton->setFixedWidth(150);

	authLayout->addRow(new QLabel(tr("User:     ")), userValue);
	authLayout->addRow(new QLabel(tr("Pass:     ")), passValue);
	authLayout->addRow(new QLabel(tr("          ")), authButton);
	
	authGroupBox->setLayout(authLayout);

	/* Network */
	workstation = new QComboBox;
	for ( int i = 0 ; i < 10 ; i++ )
		workstation->addItem(tr("Workstation %1").arg(i),i); 
	workstation->setCurrentIndex(1); 
	workstation->setFixedWidth(150);
	connect( workstation, SIGNAL( activated( int ) ), this, SLOT( workstationToIP() ) );
	sIP 	= "127.0.0.1";
	uPort = 3000;
	workstation->setEnabled(false);
	setWorkStation ( workstation->currentIndex());
	QGroupBox *networkGroupBox = new QGroupBox(tr("Network"));
	QFormLayout *networkLayout = new QFormLayout;
	
	//IPValue = new QLineEdit("127.0.0.1");
	//IPValue->setFixedWidth(150);
		
	//portValue = new QSpinBox;
	//portValue->setRange(3000, 3010);
	//portValue->setSingleStep(1);
	//portValue->setValue(2000);
	//portValue->setFixedWidth(150);

	//networkLayout->addRow(new QLabel(tr("IP:       ")), IPValue);
	//networkLayout->addRow(new QLabel(tr("Port:     ")), portValue);
	networkLayout->addRow(new QLabel(tr("Workstation")), workstation);
	
	networkGroupBox->setLayout(networkLayout);
	
	/* Storage */
	QGroupBox *storageGroupBox = new QGroupBox(tr("Storage"));
	QFormLayout *storageLayout = new QFormLayout;
	
	filePathValue 	= new QLineEdit("data");
	filePathValue->setFixedWidth(450);
	filePrefixValue 	= new QLineEdit("test");
	filePrefixValue->setFixedWidth(450);

	QPushButton *pathButton = new QPushButton("Choose Path", this);
	pathButton->setGeometry(50, 40, 75, 30);
	connect(pathButton, SIGNAL(clicked()), this, SLOT(SelectFilePath())); 

	storageLayout->addRow(new QLabel(tr("Path:  ")), filePathValue);
	storageLayout->addRow(new QLabel(tr("")), pathButton);
	storageLayout->addRow(new QLabel(tr("Prefix:")), filePrefixValue);


	storageGroupBox->setLayout(storageLayout);


	QVBoxLayout *mainLayout = new QVBoxLayout;
	mainLayout->addWidget(authGroupBox);
	mainLayout->addWidget(networkGroupBox);
	mainLayout->addWidget(storageGroupBox);

	mainLayout->addStretch(0.5);
	
	setLayout(mainLayout);
}

/****************************************
 ***************************************/

unsigned int NetworkTab::getPort ( void )
{
	//return portValue->value();
	return uPort;
}

/****************************************
 ***************************************/

void NetworkTab::setPort ( unsigned int u_port )
{
	//portValue->setValue(u_port);
	uPort = u_port;
}

/****************************************
 ***************************************/

unsigned int NetworkTab::getCameraPort ( void )
{
	//return portValue->value();
	return uCameraPort;
}

/****************************************
 ***************************************/

void NetworkTab::setCameraPort ( unsigned int u_port )
{
	//portValue->setValue(u_port);
	uCameraPort = u_port;
}
/****************************************
 ***************************************/

QString NetworkTab::getIP ( void )
{
	//return IPValue->text();
	return sIP;
}
/****************************************
 ***************************************/

void NetworkTab::setIP		( QString  s_ip )
{
	//IPValue->clear();
	//IPValue->insert(s_ip);
	sIP = s_ip;
}
/****************************************
 ***************************************/

QString NetworkTab::getFilePath ( void )
{
	return filePathValue->text();
}
/****************************************
 ***************************************/

void NetworkTab::setFilePath	( QString  s_path )
{
	filePathValue->clear();
	filePathValue->insert(s_path);
}
/****************************************
 ***************************************/

QString NetworkTab::getFilePrefix ( void )
{
	return filePrefixValue->text();
}
/****************************************
 ***************************************/

void NetworkTab::setFilePrefix	( QString  s_prefix )
{
	filePrefixValue->clear();
	filePrefixValue->insert(s_prefix);
}
/****************************************
 ***************************************/
void NetworkTab::SelectFilePath    ( void )
{
	QString dir = QFileDialog::getExistingDirectory(this, tr("Selete Data Path"), 
		".", QFileDialog::ShowDirsOnly	| QFileDialog::DontResolveSymlinks);
	setFilePath(dir);
}

/****************************************
 ***************************************/

void NetworkTab::setWorkStation    ( unsigned int index )
{
	workstation->setCurrentIndex(index);
	switch (index)
	{
		case 0:
			sIP 				= "127.0.0.1";
			uPort 			= 3000;
			uCameraPort = 80;
			break;
		default:
			sIP 	= "138.100.21.254";
			//sIP 	= "192.168.2.170";
      //uPort = 3000 + index - 1 ;
			uPort = 993 + index - 1 ;
      //uCameraPort = uPort + 10;
			uCameraPort = 143;
			break;
	}
}

/****************************************
 ***************************************/

unsigned int NetworkTab::getWorkStation    ( void )
{
	return workstation->currentIndex();
}

/****************************************
 ***************************************/

void NetworkTab::workstationToIP    ( void )
{
	setWorkStation ( workstation->currentIndex());


	/* DEBUG */
	//printf("Workstation: %d\n", workstation->currentIndex());
	//QByteArray tmp = sIP.toLatin1(); 
	//const char *tempPath = tmp.data();
	//printf("IP: %s -- Port: %d\n", tempPath, uPort);
	/* DEBUG */
}

/****************************************
 ***************************************/
		
QString NetworkTab::getUser ( void )
{
	return userValue->text();
}
/****************************************
 ***************************************/

void NetworkTab::setUser	( QString  s_user )
{
	userValue->clear();
	userValue->insert(s_user);
}
/****************************************
 ***************************************/
